var testhost = "http://test.youxiduo.com/shihou_videoclips";
var host="http://event.m.shihou.tv/shihou_videoclips";
//视频评论
var testhostComments = "http://test.open.youxiduo.com/comments";
var hostComments = "http://event.m.shihou.tv/shihou.forum.service/";
var shihouHost = "http://api.shihou.tv";
//视频列表
var videoList = host + "/video/list";
//获取视频播放地址
var videoPlayUrl = host + "/sdk/getSignUrl";
//增加视频播放次数
var videoAddPlayNumber = host + "/video/playAdd";
//视频列表分组页面
var videoIndexPlayList = host + "/video/index";
//查看文件的下载进度
var uploadProgress = host + "/video/queryProcess";
//增加点赞数量
var favourNumber = host + "/video/thumbUp";
//获取视频分类信息
var videoCategory = host + "/videoCategory/";
//判断是否点赞某一个视频
var favourStatus = host + "/video/thumbUpInfo";
//查看评论列表
var commentsList = hostComments + "/forum/query";
//增加评论
var commentsAdd = hostComments + "/forum/add";
//批量获取视频的评论数
var commentsBatchList = hostComments + "/forum/count";

//批量用户信息
var userInfoBatch = shihouHost + "/api/user/batch";
//用户信息的key
var USER_INFO_KEY = 'kwr6WcGWD3DCjdMt';
//视频id与评论id的偏移量
var offsetId = 100000;
var Ajax = function() {};

/**
 * 保存当前用户信息
 * @param {Object} userInfo  {uid,userToken,categoryId,categoryName,categoryActivity}
 */
function storageUserInfo(userInfo) {
	userInfo.categoryName = userInfo.categoryId;
	userInfo.categoryActivity = "";
	plus.storage.setItem(USER_INFO_KEY, userInfo);
	var xhr = new plus.net.XMLHttpRequest();
	xhr.onreadystatechange = function() {
		if(4 == xhr.readyState && 200 == xhr.status) {
			var result = JSON.parse(xhr.responseText);
			if(result.errorCode == 0) {
				userInfo.categoryName = result.result.categoryName;
				var uploadContent = result.result.uploadContent;
				userInfo.categoryActivity = (uploadContent == null ? '' : uploadContent);
				plus.storage.setItem(USER_INFO_KEY, JSON.stringify(userInfo));
			}
		}
	}
	xhr.open("GET", videoCategory + userInfo.categoryId, true);
	xhr.send();

}

function localUserInfo() {
	return JSON.parse(plus.storage.getItem(USER_INFO_KEY));
}
/**
 * 异步获取用户信息
 * 用户id：X-LION-UID
 * 用户TOKEN: X-LION-TOKEN
 * @param {Object} callback
 */
function getLocalUserInfoAsync(callback) {
	plus.videoplugin.getUserinfo("Html5", "Plus", "AsyncFunction", "MultiArgument!", function(result) {
		callback(JSON.parse(result[0]));
	});
}

Ajax.prototype = {
	/**
	 * 判断用户是否点赞了某一个视频
	 * @param {Object} videoId
	 * @param {Object} uid
	 * @param {Object} callback
	 */
	getFavourStatus: function(videoId, uid, callback) {
		this.postjson({
			url: favourStatus,
			data: {
				uid: uid,
				linkId: videoId
			},
			callback: function(data) {
				callback(JSON.parse(data));
			}
		});
	},
	/**
	 *  增加点赞
	 * @param {Object} videoId 视频id 
	 * @param {Object} uid 用户id
	 * @param {Object} callback
	 */
	addFavourNumber: function(videoId, uid, callback) {
		this.postjson({
			url: favourNumber,
			data: {
				uid: uid,
				linkId: videoId,
				type: 'thumbUp'
			},
			callback: function(data) {
				callback(JSON.parse(data));
			}
		});
	},

	/**
	 * 批量获取用户信息
	 * 
	 * @param {Object} userIds 2，3，4
	 * @param {Object} callback userId为key
	 */
	getUserInfoBatch: function(userIds, callback) {
		var userid = userIds.split(',');
		var i = 0;
		var params = '';
		var exits = [];
		for(i = 0; i < userid.length; i++) {
			var item = userid[i];
			if(exits.indexOf(item) < 0) {
				params += '&user_ids[]=' + userid[i];
				exits.push(item);
			}
		}
		params = params.substring(1, params.length);
		this.get({
			url: userInfoBatch + "?" + params,
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['error'] == 0) {
					var users = result['data']['users'];
					var results = {};
					users.forEach(function(item) {
						var keyName = '' + item.id;
						var name = item.nick_name;
						var avatar = item.avatar;
						results[keyName] = {
							name: item.nick_name,
							avatar: item.avatar
						};
					});
					callback(results);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 
	 * @param {Object} fileName 文件名称
	 * @param {Object} callback 回调
	 */
	getUploadProgress: function(fileName, callback) {
		this.get({
			url: uploadProgress + "?fileName=" + fileName,
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 获取评论列表
	 * 
	 * @param {Object} videoId 视频id
	 * @param {Object} pageNum 页码
	 * @param {Object} callback 数据回调
	 */
	getCommentsList: function(videoId, pageNum, callback) {
		var activityId = parseInt(offsetId) + parseInt(videoId);
		this.get({
			url: commentsList + "?activityId=" + activityId + "&pageNum=" + pageNum + "&enable=1",
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	getCommentsNumberBatch: function(videoIds, callback) {
		var param = "?activityIds=";
		for(j = 0; j < videoIds.length; j++) {
			if(0 == j) {
				param += (offsetId + parseInt(videoIds[j]));
			} else {
				param += (',' + (offsetId + parseInt(videoIds[j])))
			}
		}
		this.get({
			url: commentsBatchList + param,
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 *  增加评论
	 * @param {Object} videoId 视频id 
	 * @param {Object} uid 用户id
	 * @param {Object} content 评论内容
	 * @param {Object} callback
	 */
	addComments: function(videoId, uid, content, callback) {
		var activityId = parseInt(offsetId) + parseInt(videoId);
		this.post({
			url: commentsAdd,
			param: 'activityId=' + activityId + '&uid=' + uid + '&content=' + content,
			callback: function(data) {
				var result = JSON.parse(data);
				callback(result);
			}
		});
	},
	/**
	 * 根据视频id获取视频信息
	 * 
	 * @param {Object} id 视频id
	 * @param {Object} callback 数据回调
	 */
	getVideoInfo: function(id, callback) {
		this.postjson({
			url: videoList,
			data: {
				'id': id,
				'checkStatus': 2,
				'videoActive': true,
				'transcodeStatus': 'TranscodeSuccess'
			},
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					if(result['result'].length > 0) {
						callback(result['result'][0]);
					} else {
						alert("未找到相关的视频！");
					}
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 查询相关的视频
	 * 
	 * @param {Object} categoryId 视频分类id 
	 * @param {Object} callback 数据回调
	 */
	getSameCategoryVideos: function(categoryId, callback) {
		this.postjson({
			url: videoList,
			data: {
				'categoryId': categoryId,
				'checkStatus': 2,
				'videoActive': true,
				'transcodeStatus': 'TranscodeSuccess',
				'orderByField': 'playNum',
				'orderDirect': 'desc'
			},
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 获取我的视频列表（待审核和已发布）
	 * @param {Object} myId 我的用户id
	 * @param {Object} callback 数据回调
	 */
	getVideoListGroup: function(myId, callback) {
		this.postjson({
			url: videoIndexPlayList,
			data: {
				'editorUid': myId
			},
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 我的待审核视频
	 * @param {Object} myId 用户id
	 * @param {Object} pageNow 当前的页码
	 * @param {Object} callback 数据回调
	 */
	getMyUnPublishedVideo: function(myId, callback) {
		this.postjson({
			url: videoIndexPlayList,
			data: {
				'editorUid': myId,
				'checkStatus': 0,
				'pageNow': 1,
				'pageSize': 10
			},
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 
	 * @param {Object} myId
	 * @param {Object} pageNow
	 * @param {Object} callback
	 */
	getMyPublishedVideo: function(myId, pageNow, callback) {
		this.postjson({
			url: videoList,
			data: {
				'editorUid': myId,
				'checkStatus': 2,
				'transcodeStatus': 'TranscodeSuccess',
				'pageNow': pageNow,
				'pageSize': 10
			},
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 获取视频播放地址
	 * 
	 * @param {Object} id  视频id
	 * @param {Object} fileName 文件名称
	 * @param {Object} callback 数据回调
	 */
	getVideoPlayUrl: function(id, fileName, callback) {
		this.get({
			url: videoPlayUrl + "?videoId=" + id + "&fileName=" + fileName,
			callback: function(data) {
				var result = JSON.parse(data);
				if(result['errorCode'] == 0) {
					callback(result['result']);
				} else {
					alert(JSON.stringify(result));
				}
			}
		});
	},
	/**
	 * 增加播放次数
	 * @param {Object} videoId 视频id
	 * @param {Object} token 用户token 
	 */
	addPlayNumber: function(videoId, token) {
		this.get({
			url: videoAddPlayNumber + "?videoId=" + videoId + "&token=" + token,
			callback: function(data) {

			}
		});
	},
	get: function(data) {
		var xhr = new plus.net.XMLHttpRequest();
		xhr.onreadystatechange = function() {
			if(4 == xhr.readyState && 200 == xhr.status) {
				data.callback(xhr.responseText);
			}
		}
		xhr.open("GET", data.url, true);
		xhr.send();
	},
	post: function(data) {
		var xhr = new plus.net.XMLHttpRequest();
		xhr.onreadystatechange = function() {
			if(4 == xhr.readyState && 200 == xhr.status) {
				data.callback(xhr.responseText);
			}
		}
		xhr.open("POST", data.url, true);
		//		xhr.setRequestHeader('Content-Type','application/x-www-form-urlencoded;charset=utf-8');
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
		xhr.send(data.param);
	},
	postjson: function(data) {
		var xhr = new plus.net.XMLHttpRequest();
		xhr.onreadystatechange = function() {
			if(4 == xhr.readyState && 200 == xhr.status) {
				data.callback(xhr.responseText);
			}
		}
		xhr.open("POST", data.url, true);
		xhr.setRequestHeader('Content-Type', 'application/json');
		xhr.send(JSON.stringify(data.data));
	}
}
Ajax.prototype.constructor = Ajax;