
//唯一上传文件的key
var KEY_UNQUE_UPLOADING_VIDEO='9NkwKHYItAMjxU1z';
//服务上传地址
var URL_UPLOADING_SERVER='http://test.youxiduo.com/shihou_videoclips/upload';

//视频截图的key的前缀
var LOCAL_CACHE_VIDEO_COVER_PREFIX='VIDEO_COVER_';

/**
 * 对video的标签进行截图，在loadeddata事件后截图,返回值是以回调的方式
 * @param {Object} videoId video标签的id
 * @param {Object} scale 图片缩放比例
 */
function videoCaptureImage(videoSrc, scale, callback) {
	var video = document.createElement('video');
	video.setAttribute('id', 'video');
	video.setAttribute('src', videoSrc);
	video.setAttribute('style', 'display:none');
	document.body.appendChild(video);
	video.addEventListener('loadeddata', function() {
		var canvas = document.createElement("canvas");
		canvas.width = video.videoWidth * scale;
		canvas.height = video.videoHeight * scale;
		canvas.getContext('2d').drawImage(video, 0, 0, canvas.width, canvas.height);
		callback(canvas.toDataURL("image/png"));
	});
};

/**
 * 获取文件的大小和名称
 * @param {Object} filePath 文件路径
 * @param {Object} callback callback(filaName,fileSize)
 */
function muiFileInfo(filePath, callback) {
	plus.io.resolveLocalFileSystemURL(filePath, function(entry) {
		entry.file(function(file) {
			callback(file.name, file.size,file);
		});
	}, function(e) {
		alert("Request file system failed:" + e.message);
	});
};
/**
 * 文件大小格式化
 * @param {Object} fileSize  文件大小
 */
function fileSizeFormat(fileSize) {
	var fileSizeString;
	if(fileSize < 1048576) {
		fileSizeString = (fileSize / 1024).toFixed(2) + "KB";
	} else if(fileSize < 1073741824) {
		fileSizeString = (fileSize / 1048576).toFixed(2) + "MB";
	} else {
		fileSizeString = (fileSize / 1073741824).toFixed(2) + "GB";
	}
	return fileSizeString;
}
/**
 * 时间格式化
 * 
 * @param {Object} sec
 */
function timeFormat(sec) {
	var _this = this;
	var time = "";
	time = _this.fillZero(Math.floor(sec / 60)) + ":" + _this.fillZero(sec % 60);
	return time;
}
function fillZero(num) {
	var str = "";
	if(num < 10) {
		str = "0" + num;
	} else {
		str = num;
	}
	return str;
}

