/*
 * 	{
 *		fileName: videoplusbridge.js,
 * 		use:[
 * 			
 * 		]
 *	}
 * */

document.addEventListener("plusready", function() {
	var _BARCODE = 'videoplugin';
	var B = window.plus.bridge;
	videoplugin = {
		/**
		 * 登录
		 * @param {Object} Argus1
		 * @param {Object} Argus2
		 * @param {Object} Argus3
		 * @param {Object} Argus4
		 * @param {Object} successCallback
		 * @param {Object} errorCallback
		 */
		videoLoginSync: function(Argus1, Argus2, Argus3, Argus4, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "videoLoginSync", [callbackID, Argus1, Argus2, Argus3, Argus4]);
		},
		/**
		 * 分享
		 * @param {Object} Argus1
		 * @param {Object} Argus2
		 * @param {Object} Argus3
		 * @param {Object} Argus4
		 * @param {Object} successCallback
		 * @param {Object} errorCallback
		 */
		videoShareSync: function(Argus1, Argus2, Argus3, Argus4, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			}
			var fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			}
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "videoShareSync", [callbackID, Argus1, Argus2, Argus3, Argus4]);
		},
		/**
		 * 同步获取用户信息
		 */
		pluginUserInfoSync: function() {                  
			return B.execSync(_BARCODE, "pluginUserInfoSync", ['']);
		},
		/**
		 * 获取用户信息
		 * @param {Object} Argus1
		 * @param {Object} Argus2
		 * @param {Object} Argus3
		 * @param {Object} Argus4
		 * @param {Object} successCallback
		 * @param {Object} errorCallback
		 */
		getUserinfo: function(Argus1, Argus2, Argus3, Argus4, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "getUserinfo", [callbackID, Argus1, Argus2, Argus3, Argus4]);
		},
		/**
		 * 实时获取上传进度
		 * @param {Object} Argus1
		 * @param {Object} Argus2
		 * @param {Object} Argus3
		 * @param {Object} Argus4
		 * @param {Object} successCallback
		 * @param {Object} errorCallback
		 */
		pluginGetUploadProgress: function(Argus1, Argus2, Argus3, Argus4, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "pluginGetUploadProgress", [callbackID, Argus1, Argus2, Argus3, Argus4]);
		},

		/**
		 * 开始上传
		 * @param {Object} filePath 文件地址
		 * @param {Object} categoryId 视频分类id
		 * @param {Object} categoryName 视频分类名称
		 * @param {Object} videoSubject 视频名称
		 * @param {Object} videoFileName 上传文件名称
		 * @param {Object} uid 用户id
		 * @param {Object} videoSize 视频大小
		 * @param {Object} successCallback
		 * @param {Object} errorCallback
		 */
		pluginStartLoad: function(filePath, categoryId, categoryName, videoSubject, videoFileName, uid, videoSize, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			};
			var fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			};
			callbackID = B.callbackId(success, fail);
			return B.exec(_BARCODE, "pluginStartLoad", [callbackID, filePath, categoryId, categoryName, videoSubject, videoFileName, uid, videoSize]);
		}
	}
	window.plus.videoplugin = videoplugin;
}, true);